import java.net.*;

import java.io.*;

import java.util.*;

import java.sql.*;

import java.math.*;

import procArgs;



// Establish Multi-Threaded Connection to intraServer

class ClientConnection extends Thread {

   static final int MAX_ARGS = 5;

   static final int MAX_VALS = 100;

   static final int MAX_ATTEMPTS = 3;

   static final String QUIT_STRING = "QUIT";

   static final String CONNECT_STRING = "CONNECT";

   static int connection_number = 0;

   protected Socket client;

   protected Vulture vulture;

   protected InputStreamReader unicodein;

   protected BufferedReader in;

   protected OutputStreamWriter unicodeout;

   protected PrintWriter out;

   protected Connection con;

   protected Statement stmt;

   protected CallableStatement cstmt;

   protected String USR = new String ();

   protected String PASSWD = new String ();

   protected String APPLICATION = new String ();

	protected Integer idle_time = new Integer(0);



   public ClientConnection (Socket client_socket, ThreadGroup threadgroup,

                  int priority, Vulture vulture)

   {

      super (threadgroup, "Connection-" + connection_number++);

      this.setPriority (priority);

      client = client_socket;

      this.vulture = vulture;

      this.start ();

   }



   public String toString () {

      return this.getName () + " connected to: "

                  + client.getInetAddress ().getHostName ()

                  + ":" + client.getPort ();

   }





	protected boolean valid_command (String command, Hashtable proc_names) {

		boolean valid = false;

		Enumeration proc_keys = proc_names.keys (); 

		while (proc_keys.hasMoreElements ()) {

			if (command.equals ((String)proc_keys.nextElement ()))

				valid = true;

		}

		if (!valid) return false;

		else return true;

	}

		



	protected String[] get_args(String command, String command_line) {

		String values[] = new String[MAX_VALS];

		String value_line = command_line.substring(command.length () + 1);

		StringTokenizer pipes = new StringTokenizer (value_line,"|");

		for (int num = 1; pipes.hasMoreTokens () && num < MAX_VALS; num++)

			values[num] = new String (pipes.nextToken ());

		return values;

	}





	protected boolean check_args (Vector proc_args, String[] values) {

		Enumeration arg_keys = proc_args.elements ();

		boolean enough_args = true;

		boolean correct_type = true;

		int arg_no;

		for (arg_no = 1; arg_keys.hasMoreElements () && enough_args && 

				correct_type; arg_no++)

		{

			procArgs testArg = (procArgs)arg_keys.nextElement ();

			if (values[arg_no] == null)

				enough_args = false;

			else if (testArg.getType().equals ("NUMBER")) {

				try {

					int testnum = Integer.parseInt (values[arg_no]);

				}

				catch (NumberFormatException e) {

					correct_type = false;

				}

			}

		}

		if (values[arg_no] != null) {

			out.println ("ERROR: too many arguments provided");

			return false;

		}

		if (!enough_args) {

			out.println ("ERROR: insufficient arguments provided");

			return false;

		} 

		else if (!correct_type) {

			out.println ("ERROR: a number argument was given as a string");

			return false;

		} 

		return true;

	}



	protected void update_idle() {

		idle_time = new Integer(idle_time.intValue() + 1);

	}

	

	protected int get_idle() {

		return idle_time.intValue();

	}



}

