import java.net.*;
import java.io.*;
import java.awt.*;
import java.util.*;
import java.sql.*;
import java.math.*;

public class intraServer extends Thread {

   public final static int DEFAULT_PORT = 5000;
   protected int port;
   protected ServerSocket listen_socket;
   protected ThreadGroup threadgroup;
   protected List connection_list;
   protected Vector connections;
   protected Vulture vulture;

   public static void fail(Exception e, String msg) {
      System.err.println(msg + ":" + e);
      System.exit(1);
   }

   public intraServer(int port) {
      super("intraServer");
      if (port == 0) port = DEFAULT_PORT;
      this.port = port;
      try {
         listen_socket = new ServerSocket(port);
      }
      catch (IOException e) {
         fail(e,"Exception creating server socket");
      }
      threadgroup = new ThreadGroup("intraServer Connections");
      Frame f = new Frame("Intranet Data Server Status");
      connection_list = new List();
      f.add("Center",connection_list);
      f.setSize(450,100);
      f.show();

      connections = new Vector();

      vulture = new Vulture(this);

      this.start();
   }

   public void run() {
      try {
         while (true) {
            Socket client_socket = listen_socket.accept();
            IntranetConnection c = new IntranetConnection
					(client_socket,threadgroup,3,vulture);
            synchronized (connections) {
               connections.addElement(c);
               connection_list.addItem(c.toString());
            }
         }
      } catch (IOException e) {
         fail(e, "Exception while listening for connections");
      }
   }

   public static void main(String args[]) {

      int port = 0;
      if (args.length == 1) {
         try { port = Integer.parseInt(args[0]); }
         catch (NumberFormatException e) { port = 0; }
      }
      new intraServer(port);
   }
}



